/*
 * Here is the music. These are the speed critical routine. Optimize these as
 * good as you can and provide replacements by overwiting the respective macros.
 */


/* include replacements with processor specific optimizations here */
#if defined(__ppc__)
#include "bitmaps64_ppc.h"
#endif


#ifndef LOOKUP_FIRSTBLANK
static const char lookup_first_blank_8bit_inv[256] =  {
        9,8,7,7,6,6,6,6,5,5,5,5,5,5,5,5,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
    3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
        1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
static inline int LOOKUP_FIRSTBLANK_32(uint32_t x) {
        unsigned int a = (x>=0xffff0000?(x>=0xffffff00?0:8):(x>=0xff000000?16:24));
        return lookup_first_blank_8bit_inv[(~x>>a)]+(24-a);
}
#define LOOKUP_FIRSTBLANK(i)                                                    \
{                                                                               \
    (i>=0xFFFFFFFF00000000) ?  ( LOOKUP_FIRSTBLANK_32( (uint32_t)(i) )+32 ) :   \
        ( LOOKUP_FIRSTBLANK_32((uint32_t)(i>>32)) )                             \
}
#endif


#ifndef SET_NEXT_MARK
#define SET_NEXT_MARK                                                   \
if (comp0 < 0xfffffffffffffffe) {                                       \
    int s = LOOKUP_FIRSTBLANK( comp0 );                                 \
        if ((count[depth] += s) > limit[depth]) {break; /*goto up;*/}   \
        else {                                                          \
            CLLR_XX_BITMAPS;                                            \
        }                                                               \
} else { /* s>=64 */                                                    \
    if ((count[depth] += 64) > limit[depth]) {break; /*goto up;*/}      \
    else {                                                              \
        uint64_t temp = comp0;                                          \
        CLLR_WORD_BITMAPS;                                              \
        if (temp == 0xffffffffffffffff) {continue; /*goto stay;*/}      \
    }                                                                   \
}
#endif


#ifndef GET_DIST_CHOOSEBITS
#if ((CHOOSEBITS<=64)&&(CHOOSEBITS>0))
#define GET_DIST_CHOOSEBITS ((uint64_t)(dist0>>(64-CHOOSEBITS)))
#endif
#endif

#ifndef GET_DIST_FINALIZEBITS
#if ((FINALIZEBITS<=64)&&(FINALIZEBITS>0))
#define GET_DIST_FINALIZEBITS ((uint64_t)(dist0>>(64-FINALIZEBITS)))
#endif
#endif


#if ((NUMWORDS==1) || (NUMWORDS==2))

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint64_t lista0[MAXMARKS];      \
uint64_t compa0[MAXMARKS];      \
uint64_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint64_t dist0=0;							\
uint64_t list0=0;							\
uint64_t comp0=0;							\
lista0[depth]=0;							\
compa0[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#if (NUMWORDS==1)
#define CLLR_XX_BITMAPS						\
int ss=64-s;                                \
list0 = (list0 >> s) | (newbit << ss);      \
comp0 = (comp0 << s);                       \
list0 &= 0xffffffff00000000;
#else //(NUMWORDS==2)
#define CLLR_XX_BITMAPS						\
int ss=64-s;                                \
list0 = (list0 >> s) | (newbit << ss);      \
comp0 = (comp0 << s);
#endif
#endif

#ifndef CLLR_WORD_BITMAPS
#if (NUMWORDS==1)
#define CLLR_WORD_BITMAPS
//can not happen
#else //(NUMWORDS==2)
#define CLLR_WORD_BITMAPS					\
comp0 = 0;                                  \
list0 = newbit;                             \
newbit = 0;
#endif
#endif

#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
lista0[depth]=list0;                       \
dist0 |= list0;                             \
comp0 |= dist0;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
list0=lista0[depth];						\
dist0= dist0 & ~list0;						\
newbit=0;
#endif


#elif ((NUMWORDS==3)||(NUMWORDS==4))

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint64_t lista0[MAXMARKS];      \
uint64_t lista1[MAXMARKS];      \
uint64_t compa0[MAXMARKS];      \
uint64_t compa1[MAXMARKS];      \
uint64_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint64_t dist0=0;							\
uint64_t dist1=0;							\
uint64_t list0=0;							\
uint64_t list1=0;							\
uint64_t comp0=0;							\
uint64_t comp1=0;							\
lista0[depth]=0;							\
lista1[depth]=0;							\
compa0[depth]=0;							\
compa1[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS						\
int ss=64-s;                                \
list1 = (list1 >> s) | (list0 << ss);       \
comp0 = (comp0 << s) | (comp1 >> ss);       \
list0 = (list0 >> s) | (newbit << ss);      \
comp1 = (comp1 << s);
#endif

#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS					\
comp0 = comp1;                              \
comp1 = 0;                                  \
list1 = list0;                              \
list0 = newbit;                             \
newbit = 0;
#endif

#ifndef DEEPER_BITMAPS
#if (NUMWORDS==3)
#define DEEPER_BITMAPS						\
list1 &= 0xffffffff00000000;                \
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
newbit=1;
#else // (NUMWORDS==4)
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
newbit=1;
#endif
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
comp1=compa1[depth];						\
list0=lista0[depth];						\
list1=lista1[depth];						\
dist0= dist0 & ~list0;						\
dist1= dist1 & ~list1;						\
newbit=0;
#endif


#elif ((NUMWORDS==5)||(NUMWORDS==6))

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint32_t lista0[MAXMARKS];      \
uint32_t lista1[MAXMARKS];      \
uint32_t lista2[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t compa1[MAXMARKS];      \
uint32_t compa2[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint32_t dist0=0;							\
uint32_t dist1=0;							\
uint32_t dist2=0;							\
uint32_t list0=0;							\
uint32_t list1=0;							\
uint32_t list2=0;							\
uint32_t comp0=0;							\
uint32_t comp1=0;							\
uint32_t comp2=0;							\
lista0[depth]=0;							\
lista1[depth]=0;							\
lista2[depth]=0;							\
compa0[depth]=0;							\
compa1[depth]=0;							\
compa2[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS						\
int ss=64-s;                                \
list2 = (list2 >> s) | (list1 << ss);       \
comp0 = (comp0 << s) | (comp1 >> ss);       \
list1 = (list1 >> s) | (list0 << ss);       \
comp1 = (comp1 << s) | (comp2 >> ss);       \
list0 = (list0 >> s) | (newbit << ss);      \
comp2 = (comp2 << s);
#endif

#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS					\
comp0 = comp1;                              \
comp1 = comp2;                              \
comp2 = 0;                                  \
list2 = list1;                              \
list1 = list0;                              \
list0 = newbit;                             \
newbit = 0;
#endif

#ifndef DEEPER_BITMAPS
#if (NUMWORDS==5)
#define DEEPER_BITMAPS						\
list2 &= 0xffffffff00000000;                \
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
compa2[depth]=comp2;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
lista2[depth]=list2;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
dist2 |= list2;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
comp2 |= dist2;                             \
newbit=1;
#else //(NUMWORDS==6)
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
compa2[depth]=comp2;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
lista2[depth]=list2;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
dist2 |= list2;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
comp2 |= dist2;                             \
newbit=1;
#endif
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
comp1=compa1[depth];						\
comp2=compa2[depth];						\
list0=lista0[depth];						\
list1=lista1[depth];						\
list2=lista2[depth];						\
dist0= dist0 & ~list0;						\
dist1= dist1 & ~list1;						\
dist2= dist2 & ~list2;						\
newbit=0;
#endif



#else

#error no bitmaps defined in bitmaps64.h for your configuration of NUMWORDS

#endif
